#!/bin/sh
#*****************************
#* DPF-Wetter Version 1.1    *
#* by theobald123            *
#* Layout by fred_feuerstein *
#* Ziffern by rvk            *
#*****************************

# *-----------------------------------------------------------------------------------*
# *      HTML-Tags entfernen; Sonderzeichen ersetzen; Leerzeilen entfernen            *
# *-----------------------------------------------------------------------------------*
Substitution ()
{
	sed -e 's/<br\/>/%/g' -e 's/<[^>]*>//g' \
			-e 's/ä//g' \
			-e 's/ö//g' \
			-e 's/ü//g' \
			-e 's/AE//g' -e 's/Ae//g' \
			-e 's/OE//g' -e 's/Oe//g' \
			-e 's/UE//g' -e 's/Ue//g' -e 's/Ü//g' \
			-e 's//ss/g' -e 's//ss/g' \
			-e 's/\&deg;//g' -e 's/&nbsp;/ /g' \
			-e '/^[^0-9a-zA-Z!+-\/]*$/d'  $1 > $2
}

#************************
#* Temperatur 3-stellig *
#* Minus auf Position 1 *
#************************
normiere()
{
if [ $1 -lt 0 ]
then
	if [ $1 -le -10 ]
	then
		echo $1 > $2
	else
		a1=`echo $1 | sed -e 's/-//g'`;echo "- "$a1 > $2
	fi	
else
	if [ $1 -ge 10 ]
	then
		echo " "$1 > $2
	else	
		echo "  "$1 > $2
	fi
fi
}

#*************************************
#* Dateien und Verzeichnisse lschen *
#*************************************
remove ()
{
	rm    /tmp/dpfwetter/*.*
	rm    /tmp/dpfwetter/1/*.*
	rm    /tmp/dpfwetter/2/*.*
	rm    /tmp/dpfwetter/3/*.*
	rm    /tmp/dpfwetter/4/*.*
	rm    /tmp/dpfwetter/5/*.*
	rm    /tmp/dpfwetter/6/*.*
	rm    /tmp/dpfwetter/7/*.*
	rm    /tmp/dpfwetter/8/*.*
	rmdir /tmp/dpfwetter/1
	rmdir /tmp/dpfwetter/2
	rmdir /tmp/dpfwetter/3
	rmdir /tmp/dpfwetter/4
	rmdir /tmp/dpfwetter/5
	rmdir /tmp/dpfwetter/6
	rmdir /tmp/dpfwetter/7
	rmdir /tmp/dpfwetter/8
	rmdir /tmp/dpfwetter
}

#*************************
#* Verzeichnisse anlegen *
#*************************
init_lcd()
{
	mkdir /tmp/dpfwetter
	mkdir /tmp/dpfwetter/1
	mkdir /tmp/dpfwetter/2
	mkdir /tmp/dpfwetter/3
	mkdir /tmp/dpfwetter/4
	mkdir /tmp/dpfwetter/5
	mkdir /tmp/dpfwetter/6
	mkdir /tmp/dpfwetter/7
	mkdir /tmp/dpfwetter/8
	touch /tmp/dpfwetter/.ticker_running
}

#***************************
#* Wetterdaten aufbereiten *
#***************************
get_results ()
{
	wget -O - http://www.wetter.de/suche?searchstring=$PLZ | \
	sed -n '/\"forecastHeadLocation\"/,/8 Tage/'p | \
	sed -n -e '/forecastHead/'p \
	    -n -e '/class=\"date/'p \
	    -n -e '/headline_h4/'d \
	    -n -e '/headline_h5/'d \
	    -n -e '/\.wind/'d \
	    -n -e '/Wind in km/'d \
	    -n -e '/Risiko/'p \
	    -n -e '/Luftfeuchtigkeit/'p \
	    -n -e '/iconTitle/'p \
	    -n -e '/iconIcon/'p \
	    -n -e '/iconInfo/'p | \
	sed -e 's/^.*src=\"//g' -e 's/\.png.*$/\.png/g' > /tmp/dpfwetter/test.txt
	Substitution /tmp/dpfwetter/test.txt /tmp/dpfwetter/test1.txt    

	#Daten auslesen
	ort=`sed -n 1p /tmp/dpfwetter/test1.txt | sed -e 's/Wetter //g' `; ort=`echo $ort`;echo $ort > /tmp/dpfwetter/ort.txt
	count=1; tab1=4; tab2=5; tab3=6; tab4=7; tab5=8; tab6=9; tab7=10; tab8=11; tab9=12; tab10=13; tab11=14; step=11
	while [ $count -le $DAYS ]; do
		a1=`sed -n "$tab1"p /tmp/dpfwetter/test1.txt`;a1=`echo $a1`;echo $a1 > /tmp/dpfwetter/$count/datum.txt
 		a2=`sed -n "$tab2"p /tmp/dpfwetter/test1.txt | sed -e 's/^.*Risiko//g' | sed -e 's/%//g'`;a2=`echo $a2`;echo $a2 > /tmp/dpfwetter/$count/rain.txt
 		a3=`sed -n "$tab3"p /tmp/dpfwetter/test1.txt | sed -e 's/^.*Luftfeuchtigkeit//g' | sed -e 's/%//g'`;a3=`echo $a3`;echo $a3 > /tmp/dpfwetter/$count/hydro.txt;
 		a4=`sed -n "$tab4"p /tmp/dpfwetter/test1.txt`;a4=`echo $a4`;wget -O /tmp/dpfwetter/$count/wetter1.png $a4
 		a5=`sed -n "$tab5"p /tmp/dpfwetter/test1.txt | sed -e 's/.*$//g' -e 's/ //g'`;a5=`echo $a5`;normiere $a5  /tmp/dpfwetter/$count/temp1.txt;
 		a6=`sed -n "$tab6"p /tmp/dpfwetter/test1.txt`;a6=`echo $a6`;wget -O /tmp/dpfwetter/$count/wetter2.png $a6
 		a7=`sed -n "$tab7"p /tmp/dpfwetter/test1.txt | sed -e 's/.*$//g' -e 's/ //'g`;a7=`echo $a7`;normiere $a7  /tmp/dpfwetter/$count/temp2.txt;
 		a8=`sed -n "$tab8"p /tmp/dpfwetter/test1.txt`;a8=`echo $a8`;wget -O /tmp/dpfwetter/$count/wetter3.png $a8
 		a9=`sed -n "$tab9"p /tmp/dpfwetter/test1.txt | sed -e 's/.*$//g' -e 's/ //'g`;a9=`echo $a9`;normiere $a9  /tmp/dpfwetter/$count/temp3.txt;
 		a10=`sed -n "$tab10"p /tmp/dpfwetter/test1.txt`;a10=`echo $a10`;wget -O /tmp/dpfwetter/$count/wetter4.png $a10
 		a11=`sed -n "$tab11"p /tmp/dpfwetter/test1.txt | sed -e 's/.*$//g' -e 's/ //'g`;a11=`echo $a11`;normiere $a11  /tmp/dpfwetter/$count/temp4.txt;
		count=`expr "$count" + 1`; tab1=`expr "$tab1" + $step`; tab2=`expr "$tab2" + $step`; tab3=`expr "$tab3" + $step`; tab4=`expr "$tab4" + $step`; tab5=`expr "$tab5" + $step`; tab6=`expr "$tab6" + $step`; tab7=`expr "$tab7" + $step`; tab8=`expr "$tab8" + $step`; tab9=`expr "$tab9" + $step`; tab10=`expr "$tab10" + $step`; tab11=`expr "$tab11" + $step`
	done

	while [ -e /tmp/dpfwetter/.ticker_running ]; do
		#Screens durchwechseln
		count=1
		while [ $count -le $DAYS ]; do
			cp /tmp/dpfwetter/$count/*.* /tmp/dpfwetter
			sleep $REFRESH
			count=`expr "$count" + 1`
		done
	done
}

PLZ=$1
DAYS=$2
REFRESH=$3
echo "Test:" $PLZ$DAYS$REFRESH
remove
init_lcd
killall lcd4linux
sleep 3
/bin/lcd4linux -f /var/lcd/dpfwetter.conf
get_results
killall lcd4linux
sleep 3
exec $lcd4linux_call
remove
exit