#!/bin/sh
#*****************************
#* DPF-Wetter Version 1.1    *
#* by theobald123            *
#* Layout by fred_feuerstein *
#* Ziffern by rvk            *
#*****************************

#*************************************
#* Dateien und Verzeichnisse lschen *
#*************************************
remove ()
{
	rm    /tmp/dpfwetter/*.*
	rm    /tmp/dpfwetter/1/*.*
	rm    /tmp/dpfwetter/2/*.*
	rm    /tmp/dpfwetter/3/*.*
	rm    /tmp/dpfwetter/4/*.*
	rm    /tmp/dpfwetter/5/*.*
	rm    /tmp/dpfwetter/6/*.*
	rm    /tmp/dpfwetter/7/*.*
	rm    /tmp/dpfwetter/8/*.*
	rmdir /tmp/dpfwetter/1
	rmdir /tmp/dpfwetter/2
	rmdir /tmp/dpfwetter/3
	rmdir /tmp/dpfwetter/4
	rmdir /tmp/dpfwetter/5
	rmdir /tmp/dpfwetter/6
	rmdir /tmp/dpfwetter/7
	rmdir /tmp/dpfwetter/8
	rmdir /tmp/dpfwetter
}

# ************************************************
# *      Einlesen der Postleitzahl               *
# *----------------------------------------------*
# *      bergabeparameter : Postleitzahlendatei *
# ************************************************

getplz ()
{
conf=$1

if [ -s $conf ] ; then
	Eingabe=`cat "$conf"`
else
	# Eingabemaske
	Eingabe=`input l="PLZ:    #####     Vorhersage: # TageAnzeige:   ## Sek." o=45 c=18`
	if [ "$Eingabe" = "" ] ; then
		rm $conf
		exit
	else
		echo $Eingabe > $conf
	fi
fi

PLZ=`cut -b  1-5 $conf`; PLZ=`echo $PLZ`
#if [ $PLZ -lt 10000 ] ; then
#	wget -q -O - http://127.0.0.1/control/message?popup="PLZ ungueltig"
#	rm $conf
#	exit
#fi

DAYS=`cut -b 6 $conf`; DAYS=`echo $DAYS`
if [ "$DAYS" = "" ] ; then
	DAYS=8
elif [ $DAYS -lt 1 -o $DAYS -gt 8 ] ; then
	DAYS=8
fi

REFRESH=`cut -b 7-8 $conf`; REFRESH=`echo $REFRESH`
if [ "$REFRESH" = "" ] ; then
	REFRESH=20
fi

echo $PLZ"$DAYS"$REFRESH > $conf
}

if [ -e /tmp/dpfwetter/.ticker_running ]; then
	#****************************************************
	#* Ticker beenden und alte Anzeige wiederherstellen *
	#****************************************************
	lcd4linux_call=`cat /tmp/lcd4linux_call.txt`
	rm /tmp/dpfwetter/.ticker_running
	rm /tmp/lcd4linux_call.txt
	killall dpfwetter.sh
	killall lcd4linux
	remove
	wget -q -O - http://127.0.0.1/control/message?popup="DPFwetter wurde beendet"
	sleep 3
	exec $lcd4linux_call
else
	#**************************************************************
	#* PLZ, Vorhersagetage und Anzeigedauer auswhlen und sichern *
	#**************************************************************
	getplz /var/tuxbox/config/dpfwetter.plz
	/var/plugins/dpfwetter.sh $PLZ $DAYS $REFRESH &
	wget -q -O - http://127.0.0.1/control/message?popup="DPFwetter wurde gestartet%0AZur erneuten PLZ-Eingabe bitte%0A%0A/var/tuxbox/config/dpfwetter.plz%0A%0Aloeschen"
	ps -AF > /tmp/ticker1.txt
	sed -n /lcd4linux/p /tmp/ticker1.txt | sed -e 's/lcd4linux.*/&%&/' | sed -e 's/^.*%//' > /tmp/lcd4linux_call.txt
	rm /tmp/ticker1.txt
fi
service lcd4linux reload
exit
