#!/bin/sh
#*******************************************
#* LCD-Ticker Version 1.0                  *
#* by theobald123 and Tischi               *
#*******************************************

#*************************************
#* Dateien und Verzeichnisse lschen *
#*************************************
remove ()
{
	rm    /tmp/lcdticker/*.*
	rm    /tmp/lcdticker/1/*.*
	rm    /tmp/lcdticker/2/*.*
	rm    /tmp/lcdticker/3/*.*
	rmdir /tmp/lcdticker/1
	rmdir /tmp/lcdticker/2
	rmdir /tmp/lcdticker/3
	rmdir /tmp/lcdticker
}

#*******************************************
#* Logo-Verzeichnis und Spieltag ermitteln *
#*******************************************
init_lcd()
{
	mkdir /tmp/lcdticker
	mkdir /tmp/lcdticker/1
	mkdir /tmp/lcdticker/2
	mkdir /tmp/lcdticker/3
	touch /tmp/lcdticker/.ticker_running

	logoverz=`wget -q -O - http://www.bundesliga.de/de | sed -n '/teasericon_event/p' | sed -n '1p' | sed -e 's/^.*src=\"//g' -e 's/wappen.*$/wappen/g'`
	spieltagurl=`wget -q -O - http://mobil.bundesliga.de/de/$1/index | sed -n '/SPIELPLAN/p' | sed -n '1p' | sed -e 's/^.*href=\"//g' | sed -e 's/\".*$//g'`
}

#**********************
#* Vereinslogos holen *
#**********************
get_logos ()
{
	wget -q -O - http://mobil.bundesliga.de$spieltagurl | sed -n '/pic25/p' | sed -e 's/^.*(\/data\//data/g' -e 's/).*$//g' | sed -e 's/^.*\///g' > /tmp/lcdticker/ticker1.txt
	count=1
	while [ $count -le 18 ]; do
		logo=`sed -n "$count"p /tmp/lcdticker/ticker1.txt`
		wget -q -O /tmp/lcdticker/$count.png $logoverz/80/$logo
		count=`expr "$count" + 1`
	done

	#***************************
	#* auf 3 Screens aufteilen *
	#***************************
	mv /tmp/lcdticker/1.png  /tmp/lcdticker/1/A.png
	mv /tmp/lcdticker/2.png  /tmp/lcdticker/1/B.png
	mv /tmp/lcdticker/3.png  /tmp/lcdticker/1/C.png
	mv /tmp/lcdticker/4.png  /tmp/lcdticker/1/D.png
	mv /tmp/lcdticker/5.png  /tmp/lcdticker/1/E.png
	mv /tmp/lcdticker/6.png  /tmp/lcdticker/1/F.png

	mv /tmp/lcdticker/7.png  /tmp/lcdticker/2/A.png
	mv /tmp/lcdticker/8.png  /tmp/lcdticker/2/B.png
	mv /tmp/lcdticker/9.png  /tmp/lcdticker/2/C.png
	mv /tmp/lcdticker/10.png /tmp/lcdticker/2/D.png
	mv /tmp/lcdticker/11.png /tmp/lcdticker/2/E.png
	mv /tmp/lcdticker/12.png /tmp/lcdticker/2/F.png

	mv /tmp/lcdticker/13.png /tmp/lcdticker/3/A.png
	mv /tmp/lcdticker/14.png /tmp/lcdticker/3/B.png
	mv /tmp/lcdticker/15.png /tmp/lcdticker/3/C.png
	mv /tmp/lcdticker/16.png /tmp/lcdticker/3/D.png
	mv /tmp/lcdticker/17.png /tmp/lcdticker/3/E.png
	mv /tmp/lcdticker/18.png /tmp/lcdticker/3/F.png
}

#****************************************
#* Ergebnisdatei erstellen und anzeigen *
#****************************************
get_results ()
{
	while [ -e /tmp/lcdticker/.ticker_running ]; do
		wget -q -O - http://mobil.bundesliga.de$spieltagurl | sed -n '/score/p' | sed -e 's/^.*score">//g' -e 's/<\/div.*$//g'> /tmp/lcdticker/ticker2.txt
		sed -n 1,3p /tmp/lcdticker/ticker2.txt > /tmp/lcdticker/1/ticker.txt
		sed -n 4,6p /tmp/lcdticker/ticker2.txt > /tmp/lcdticker/2/ticker.txt
		sed -n 7,9p /tmp/lcdticker/ticker2.txt > /tmp/lcdticker/3/ticker.txt
		#*************************
		#* Screens durchwechseln *
		#*************************
		count=1
		while [ $count -le 3 ]; do
			cp /tmp/lcdticker/$count/*.* /tmp/lcdticker
			sleep 15
			count=`expr "$count" + 1`
		done
	done
}

remove
init_lcd "$1"
get_logos
cp /tmp/lcdticker/1/*.* /tmp/lcdticker
killall lcd4linux
sleep 3
/bin/lcd4linux -f /var/lcd/lcdticker.conf
get_results
killall lcd4linux
sleep 3
exec $lcd4linux_call
remove
exit